%global __brp_check_rpaths %{nil}

%define anolis_release 2

%define         resty_prefix     /usr/share
%define         resty_user       nobody
%define         resty_group      nobody
%define         dir_name      openresty

Name:		openresty

Version:	1.22.1.0
Release:	%{anolis_release}%{?dist}
Summary:	nginx for openresty

Group:		Productivity/Networking/Web/Servers
License:	BSD
URL:		http://www.openresty.org/

Source0:	openresty-%{version}.tar.gz

BuildRoot:	%{build_root}

AutoReqProv:    no
BuildRequires:	gcc >= 3.0, chrpath, openssl1.1-devel, pcre-devel, readline-devel, libpq-devel, libdlb-devel, gd-devel, libxslt-devel, qatzip-devel, perl-ExtUtils-Embed
Requires:	openssl1.1, pcre, readline, libpq, libdlb, qatzip, qatengine

ExclusiveArch: x86_64

%description
OpenResty is a full-fledged web application server by bundling the anolis accelerated (laveraging intel QAT and DLB for TLS and load balance) Nginx core, lots of 3rd-party Nginx modules, as well as most of their external dependencies

%prep
%setup -q -n openresty-%{version}

%build
./configure --prefix=%{resty_prefix}/%{dir_name} \
            --with-file-aio \
            --with-pcre-jit \
            --with-stream=dynamic \
            --with-stream_ssl_module \
            --with-stream_ssl_preread_module \
            --with-http_xslt_module=dynamic \
            --with-http_v2_module \
            --with-http_stub_status_module \
            --with-http_realip_module \
            --with-http_addition_module \
            --with-http_auth_request_module \
            --with-http_secure_link_module \
            --with-http_random_index_module \
            --with-http_gzip_static_module \
            --with-http_image_filter_module=dynamic \
            --with-http_sub_module \
            --with-http_dav_module \
            --with-http_flv_module \
            --with-http_mp4_module \
            --with-http_gunzip_module \
            --with-http_degradation_module \
            --with-http_slice_module \
            --with-http_stub_status_module \
            --with-mail=dynamic \
            --with-mail_ssl_module \
            --with-threads \
            --with-compat \
            --with-http_postgres_module \
            --with-http_ssl_module \
            --without-mail_pop3_module \
            --without-mail_imap_module \
            --without-mail_smtp_module \
            --add-dynamic-module=bundle/nginx-1.22.1/modules/nginx_qatzip_module \
            --add-dynamic-module=bundle/nginx-1.22.1/modules/nginx_qat_module/ \
            --with-ld-opt="-L$OPENSSL_LIB/lib64 -lqatzip -ldlb -lpcre -lz" \
            --with-cc="gcc -fdiagnostics-color=always" \
            --with-cc-opt="-O2 -DNGX_LUA_ABORT_AT_PANIC"

make %{?_smp_mflags}

%install
make install DESTDIR=$RPM_BUILD_ROOT

cur_dir=`pwd`

cd $RPM_BUILD_ROOT%{resty_prefix}/%{dir_name}/nginx/ && \
    mkdir client_body_temp fastcgi_temp proxy_temp

cd $RPM_BUILD_ROOT && (find . -type f | sed -e 's|^./|/|g' > $cur_dir/%{name}.manifest)
cd $RPM_BUILD_ROOT && (find . -type l | sed -e 's|^./|/|g' >> $cur_dir/%{name}.manifest)

echo %{resty_prefix}/%{dir_name}/nginx/logs >> $cur_dir/%{name}.manifest
echo %{resty_prefix}/%{dir_name}/nginx/client_body_temp >> $cur_dir/%{name}.manifest
echo %{resty_prefix}/%{dir_name}/nginx/fastcgi_temp >> $cur_dir/%{name}.manifest
echo %{resty_prefix}/%{dir_name}/nginx/proxy_temp >> $cur_dir/%{name}.manifest

#echo %{resty_prefix}/%{dir_name}/nginx/proxy_temp >> $cur_dir/%{name}.manifest

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.manifest
%license COPYRIGHT
%defattr(-,%{resty_user},%{resty_group},-)
%dir %{resty_prefix}/%{dir_name}
%doc README.markdown README-windows.txt

%changelog
* Thu Sep 21 2023 Guanjun <guanjun@linux.alibaba.com> - 1.22.1.0-2
- add openssl1.1 and qatengine requires

* Fri Aug 04 2023 Guanjun <guanjun@linux.alibaba.com> - 1.22.1.0-1
- integrate aysnch mode nginx for leveraging Intel QAT (Intel QuickAssist Technology) and Intel DLB (Dynamic Load Balancer)

